/* Copyright Apple Computer, Inc. 1981-1988 */

#ifndef	__MACSBUGREZ__
#define __MACSBUGREZ__

/*
	'mxwt' is a new resource type for templates. The only difference is a word count
	for the number of fields in a type. 'mxbt' used a byte count. 'mxbt' is still
	supported.  However, you need the word count if you want to use ResEdit to create
	templates.
*/

type 'mxwt'{
	integer = $$CountOf(templates);					/* Number of templates               */
	array templates { pString;						/* Type name                         */
				      integer = $$CountOf(fields);  /* Number of fields in this template */
				      array fields { pString;	    /* Field name                        */
								     pString;       /* Field type                        */
								     integer;		/* Number of fields of this type     */
							       };
    			    };
};

	/* Sample shows all possible types:
	"Sample", {
	 	"Byte",				"Byte",				1,
	 	"Signed Byte",		"SignedByte",		1,
	 	"Unsigned Byte",	"UnsignedByte",		1,
	 	"Align to word",	"Align",			1,
	 	"Word",				"Word",				1,
	 	"Signed Word",		"SignedWord",		1,
	 	"Unsigned Word",	"UnsignedWord",		1,
	 	"Long",				"Long",				1,
	 	"Signed Long",		"SignedLong",		1,
	 	"Unsigned Long",	"UnsignedLong",		1,
		"Boolean",			"Boolean",			1,
		"Padding",			"Skip",  			1,
		"Pascal string",	"pString",  		10,
		"C string",			"cString",  		1,
	 	"Align to word",	"Align",			1,
		"Text",				"Text",				4,
		"Handle",			"Handle",			1,
		"Pointer",			"Pointer",			1,
		"Next",				"^Sample",			1
		},
	*/


/*
	The 'mxbc' resource sets the foreground and background colors for
	the MacsBug display.  The default is black characters on a white background.
*/

type 'mxbc' {
		unsigned integer;		/* Background RGB:	red		*/
		unsigned integer;						/*	green	*/
		unsigned integer;						/*	blue	*/
		unsigned integer;		/* Foreground RGB:	red		*/
		unsigned integer;						/*	green	*/
		unsigned integer;						/*	blue	*/
};	

/*
	The 'mxbm' resource creates macros in the same manner as the mc command in
	MacsBug.
*/

type 'mxbm'{
	integer = $$CountOf(symbols);          /* Number of entries     */
	array symbols { pString; pString; };   /* Macro name; expansion */
};

/* 

The 'mxbi' resource initializes MacsBug options for:

	 The number of traps that are recorded using ATR/ATP commands
	 The number of lines in the PC window
	 The number of bytes used to save the command history

If no mxbi resource is found then MacsBug defaults to:

	 16 traps recorded
	 2  lines in the PC window
	 2K bytes of command history

*/

type 'mxbi' {
	unsigned integer;		/* How many traps to record							*/
	unsigned integer;		/* Number of lines displayed in the PC window		*/
	unsigned integer;		/* Number of bytes used to save the command history	*/
};

#endif