//--------------------------------------------------------------------------
//
//		MyMediaComponent.h
//			by John Wang
//
//		Version:	1.0		02/25/93	Based on MyComponent shell.
//
//--------------------------------------------------------------------------

//
//	#defines
//

#define		DEBUGME					0	//	0 for no debug
										//	1 for full debug
										//	2 for nothing but media component specific calls.
#define		kMyComponentSpec		1
#define		kMyComponentVersion		0

//--------------------------------------------------------------------------

//	Globals Definitions.

typedef struct	{
	//	Component stuff
	ComponentInstance	delegate;				//	keep track who we are delegating it to.
	ComponentInstance	self;					//	self instance needed by MediaInitialize
	
	//	Characteristics
	Movie				myMovie;
	Track				myTrack;
	Media				myMedia;
	Fixed				mediaRate;
	Rect				graphicsBox;
	MatrixRecord		trackMatrix;
	CGrafPtr			port;
	GDHandle			device;
	long				sampleDescIndex;

	//	Media globals
	long				somethingChanged;
	Boolean				enabled;
	Fixed				newMediaRate;			//	Store new rate in here
	TimeValue			lastMediaTime;			//	Need to know last drawn media time
} PrivateGlobals;

//--------------------------------------------------------------------------

//	Prototypes.

pascal ComponentResult main(ComponentParameters *params, PrivateGlobals **storage);
pascal ComponentResult MyOpen(ComponentInstance self);
pascal ComponentResult MyClose(PrivateGlobals **storage, ComponentInstance self);
pascal ComponentResult MyCanDo(short selector);
pascal ComponentResult MyVersion(void);
pascal ComponentResult MyRegister(PrivateGlobals **storage);
