//--------------------------------------------------------------------------
//
//		MyMediaComponentRoutines.h
//			by John Wang
//
//		Version:	1.0		02/25/93	Based on MyComponent shell.
//
//--------------------------------------------------------------------------

//
//	Defines
//

#define	kNoneChanged		0x0000
#define	kSetActive			0x0001
#define	kSetRate			0x0002
#define	kTrackEdited		0x0004
#define	kSetGWorld			0x0008
#define	kSetDimensions		0x0010
#define	kSetMatrix			0x0020
#define	kSampleDescChanged	0x0040

//--------------------------------------------------------------------------

//	Prototypes.

pascal ComponentResult MyMediaInitialize(PrivateGlobals **storage,
										GetMovieCompleteParams	*gmc);
pascal ComponentResult MyMediaIdle(PrivateGlobals **storage,
										TimeValue atMediaTime, long flagsIn,
										long *flagsOut, const TimeRecord *movieTime);
pascal ComponentResult MyMediaSetActive(PrivateGlobals **storage,
										Boolean enableMedia);
pascal ComponentResult MyMediaSetRate(PrivateGlobals **storage,
										Fixed rate);
pascal ComponentResult MyMediaTrackEdited(PrivateGlobals **storage);
pascal ComponentResult MyMediaSetGWorld(PrivateGlobals **storage,
										CGrafPtr aPort, GDHandle aGD);
pascal ComponentResult MyMediaSetDimensions(PrivateGlobals **storage,
										Fixed width, Fixed height);
pascal ComponentResult MyMediaSetMatrix(PrivateGlobals **storage,
										MatrixRecord *trackMovieMatrix);
pascal ComponentResult MyMediaSampleDescriptionChanged(PrivateGlobals **storage,
										long index);