/*
  File:			mtb.h
  Contains:		Header File for the Inside Mac Movie Toolbox Code
  Written by:	DTS and QT Engineering
  Copyright:	 1992-1994 by Apple Computer, Inc., all rights reserved.
  Change History (most recent first):
  <1>	 	12/4/94	khs		changed the format of the file to the new look and feel
  To Do:
*/


//  This file contains all of the prototypes for the Inside Macintosh
//  Movie Toolbox Example code.


// INCLUDES
#include <Fonts.h>
#include <Quickdraw.h>
#include <GestaltEqu.h>
#include <Script.h>
#include <Packages.h>
#include <Resources.h>
#include <Sound.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <FixMath.h>

#include <ImageCompression.h>
#include <Movies.h>


// FUNCTION PROTOTYPES
Boolean IsQuickTimeInstalled(void);
Movie GetMovie(void);
void CheckError(OSErr error,
				Str255 displayString);

void InitMovieToolbox(void);
void CreateMyCoolMovie(void);
void CreateMyVideoTrack(Movie theMovie);
void AddVideoSamplesToMedia(Media theMedia,
							const Rect* trackFrame);
void DrawFrame(const Rect* trackFrame,
			   long curSample);
void CreateMySoundTrack(Movie theMovie);
void CreateSoundDescription(Handle sndHandle,
							SoundDescriptionHandle sndDesc,
							long* sndDataOffset,
							long* numSamples,
							long* sndDataSize);
long GetSndHdrOffset(Handle sndHandle);

void DoUpdate(WindowPtr theWindow,
			  Movie theMovie);

pascal OSErr MyCoverProc(Movie aMovie,
						 RgnHandle changedRgn,
						 long refcon);
pascal OSErr MyUnCoverProc(Movie aMovie,
						   RgnHandle changedRgn,
						   long refcon);
void InitCoverProcs(WindowPtr aWindow,
					Movie aMovie);

void CreateTrackMatte(Track theTrack);
void UpdateTrackMatte(Track theTrack);
