/*
 	File:		ImageCodec.k.h
 
 	Contains:	QuickTime interfaces
 
 	Version:	
 
 	DRI:		Jim Batson
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.
 				All rights reserved.
 
 	Warning:	*** APPLE INTERNAL USE ONLY ***
 				This file may contain unreleased API's
 
 	BuildInfo:	Built by:			QuickTime
 				With Interfacer:	2.0d12e5 (PowerPC native)
 				From:				ImageCodec.i
 					Revision:		0
 					Dated:			4/25/96
 					Last change by:	JB
 					Last comment:	This is a fake header used so interfacer is happy.
 
 	Bugs:		Report bugs to Radar component System Interfaces, Latest
 				List the version information (from above) in the Problem Description.
 
*/
#ifndef __IMAGECODEC_K__
#define __IMAGECODEC_K__

#include <ImageCodec.h>

/*	codec capabilities flags	*/
/*	codec condition flags	*/

#ifndef IMAGECODEC_BASENAME
	#error IMAGECODEC_BASENAME must be defined to use this file
#endif
#ifndef IMAGECODEC_GLOBALS
	#error IMAGECODEC_GLOBALS must be defined to use this file
#endif
#define ADD_IMAGECODEC_BASENAME(name) IMAGECODEC_BASENAME()##name

/*	codec selectors 0-127 are reserved by Apple */
/*	codec selectors 128-191 are subtype specific */
/*	codec selectors 192-255 are vendor specific */
/*	codec selectors 256-32767 are available for general use */
/*	negative selectors are reserved by the Component Manager */
extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetCodecInfo) (IMAGECODEC_GLOBALS(), CodecInfo * info);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetCompressionTime) (IMAGECODEC_GLOBALS(), PixMapHandle  src, const Rect * srcRect, short  depth, CodecQ * spatialQuality, CodecQ * temporalQuality, unsigned long * time);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetMaxCompressionSize) (IMAGECODEC_GLOBALS(), PixMapHandle  src, const Rect * srcRect, short  depth, CodecQ  quality, long * size);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(PreCompress) (IMAGECODEC_GLOBALS(), CodecCompressParams * params);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(BandCompress) (IMAGECODEC_GLOBALS(), CodecCompressParams * params);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(PreDecompress) (IMAGECODEC_GLOBALS(), CodecDecompressParams * params);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(BandDecompress) (IMAGECODEC_GLOBALS(), CodecDecompressParams * params);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(Busy) (IMAGECODEC_GLOBALS(), ImageSequence  seq);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetCompressedImageSize) (IMAGECODEC_GLOBALS(), ImageDescriptionHandle  desc, Ptr  data, long  bufferSize, ICMDataProcRecordPtr  dataProc, long * dataSize);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetSimilarity) (IMAGECODEC_GLOBALS(), PixMapHandle  src, const Rect * srcRect, ImageDescriptionHandle  desc, Ptr  data, Fixed * similarity);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(TrimImage) (IMAGECODEC_GLOBALS(), ImageDescriptionHandle  Desc, Ptr  inData, long  inBufferSize, ICMDataProcRecordPtr  dataProc, Ptr  outData, long  outBufferSize, ICMFlushProcRecordPtr  flushProc, Rect * trimRect, ICMProgressProcRecordPtr  progressProc);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(RequestSettings) (IMAGECODEC_GLOBALS(), Handle  settings, Rect * rp, ModalFilterUPP  filterProc);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(GetSettings) (IMAGECODEC_GLOBALS(), Handle  settings);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(SetSettings) (IMAGECODEC_GLOBALS(), Handle  settings);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(Flush) (IMAGECODEC_GLOBALS());

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(SetTimeCode) (IMAGECODEC_GLOBALS(), void * timeCodeFormat, void * timeCodeTime);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(IsImageDescriptionEquivalent) (IMAGECODEC_GLOBALS(), ImageDescriptionHandle  newDesc, Boolean * equivalent);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(NewMemory) (IMAGECODEC_GLOBALS(), Ptr * data, Size  dataSize, long  dataUse, ICMMemoryDisposedUPP  memoryGoneProc, void * refCon);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(DisposeMemory) (IMAGECODEC_GLOBALS(), Ptr  data);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(HitTestData) (IMAGECODEC_GLOBALS(), ImageDescriptionHandle  desc, void * data, Size  dataSize, Point  where, Boolean * hit);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(NewImageBufferMemory) (IMAGECODEC_GLOBALS(), CodecDecompressParams * params, long  flags, ICMMemoryDisposedUPP  memoryGoneProc, void * refCon);

extern pascal ComponentResult ADD_IMAGECODEC_BASENAME(ExtractAndCombineFields) (IMAGECODEC_GLOBALS(), long  fieldFlags, void * data1, long  dataSize1, ImageDescriptionHandle  desc1, void * data2, long  dataSize2, ImageDescriptionHandle  desc2, void * outputData, long * outDataSize, ImageDescriptionHandle  descOut);


/* MixedMode ProcInfo constants for component calls */
enum {
	uppImageCodecGetCodecInfoProcInfo = 0x000003F0,
	uppImageCodecGetCompressionTimeProcInfo = 0x000FEFF0,
	uppImageCodecGetMaxCompressionSizeProcInfo = 0x0003EFF0,
	uppImageCodecPreCompressProcInfo = 0x000003F0,
	uppImageCodecBandCompressProcInfo = 0x000003F0,
	uppImageCodecPreDecompressProcInfo = 0x000003F0,
	uppImageCodecBandDecompressProcInfo = 0x000003F0,
	uppImageCodecBusyProcInfo = 0x000003F0,
	uppImageCodecGetCompressedImageSizeProcInfo = 0x0003FFF0,
	uppImageCodecGetSimilarityProcInfo = 0x0003FFF0,
	uppImageCodecTrimImageProcInfo = 0x03FFFFF0,
	uppImageCodecRequestSettingsProcInfo = 0x00003FF0,
	uppImageCodecGetSettingsProcInfo = 0x000003F0,
	uppImageCodecSetSettingsProcInfo = 0x000003F0,
	uppImageCodecFlushProcInfo = 0x000000F0,
	uppImageCodecSetTimeCodeProcInfo = 0x00000FF0,
	uppImageCodecIsImageDescriptionEquivalentProcInfo = 0x00000FF0,
	uppImageCodecNewMemoryProcInfo = 0x0003FFF0,
	uppImageCodecDisposeMemoryProcInfo = 0x000003F0,
	uppImageCodecHitTestDataProcInfo = 0x0003FFF0,
	uppImageCodecNewImageBufferMemoryProcInfo = 0x0000FFF0,
	uppImageCodecExtractAndCombineFieldsProcInfo = 0x0FFFFFF0
};

#endif /* __IMAGECODEC_K__ */

