
#include "BigEasy2.h"
#include "BigEasyTextish.h"
#include "BigEasyDialogs.h"
#include "Instrument Editor.h"



static Handle BuildMusicHeader(TDoc *d);
static Handle BuildMusicScore(TDoc *d,long *duration);

static long gScale = 12;



void InstEditDialog(short n, short menuItem, short menuRef)
	{
	AtomicInstrument iH;
	TDoc *d;
	ComponentResult result;

	d = &gDoc[n - kFirstDocWindow];

	GoWatch();
	result = MusicGetPartAtomicInstrument(d->ci,d->part,&iH,0);
	GoArrow();

	//result = NAEditInstrument(d->na,nil,
	//	"\pFish",
	//	0,
	//	iH,0);

	}



void PitchBendDoc(short n, short menuItem, short menuRef)
	{
	long t;
	long i;
	long x;
	TDoc *d;
	ComponentResult result;

	d = &gDoc[n - kFirstDocWindow];

	x = EasyDialogGetNumber("\pScale",
			"\pNumber of notes in equal tempered octave:",
			&gScale);

	if(x && gScale > 0 && gScale < 100)
		{
		GoWatch();
		result = MusicPlayNote(d->ci,1,60,100);
		Delay(15,&t);
		for(i = -gScale; i <= gScale; i++)
			{
			MusicSetPartController(d->ci,1,kControllerPitchBend,i * (12<<8) / gScale);
			Delay(12,&t);
			}
		result = MusicPlayNote(d->ci,1,60,0);		
		MusicSetPartController(d->ci,1,kControllerPitchBend,0);
		}


	GoArrow();
	}

void MicrotoneDoc(short n, short menuItem, short menuRef)
	{
	long t;
	long i;
	long x;
	long p;
	TDoc *d;
	ComponentResult result;

	d = &gDoc[n - kFirstDocWindow];

	x = EasyDialogGetNumber("\pScale",
			"\pNumber of notes in equal tempered octave:",
			&gScale);

	if(x && gScale > 0 && gScale < 100)
		{
		GoWatch();
		Delay(15,&t);
		for(i = -gScale; i <= gScale; i++)
			{
			p = (60<<8) + (i * (12<<8) / gScale);
			result = MusicPlayNote(d->ci,1, p,100);
			Delay(12,&t);
			result = MusicPlayNote(d->ci,1, p,0);
			Delay(3,&t);
			}
		}


	GoArrow();
	}


void NotesOnDoc(short n, short menuItem, short menuRef)
	{
	ComponentResult result;
	TDoc *d;

	d = &gDoc[n - kFirstDocWindow];
	result = MusicPlayNote(d->ci,1,60,100);
	result = MusicPlayNote(d->ci,1,67,70);
	}

void NotesOffDoc(short n, short menuItem, short menuRef)
	{
	ComponentResult result;
	TDoc *d;

	d = &gDoc[n - kFirstDocWindow];
	result = MusicPlayNote(d->ci,1,60,0);
	result = MusicPlayNote(d->ci,1,67,0);
	}


Handle BuildMusicHeader(TDoc *d)
	{
#if 0
	unsigned long size,iHSize,nrEventSize;
	NoteRequest *nr;
	unsigned long *w;
	AtomicInstrument iH;
	MusicDescriptionHandle mdH;
	ComponentResult thisError;

	mdH = 0;

	GoWatch();
	thisError = MusicGetPartAtomicInstrument(d->ci,d->part,&iH,0);
	HLock((Handle)iH);
	GoArrow();
	FlashResult(thisError);

	if(thisError)
		goto goHome;

	size = GetHandleSize((Handle)iH);
	iHSize = size;
	size += sizeof(NoteRequest) - sizeof(ToneDescription);	/* iH is just a tonedescription + knoblist */
	size += 8;		/* general music message */
	nrEventSize = size / 4;
	size += 4;		/* end marker */

	size += sizeof(MusicDescription) - 4;		/* lose the one included longword of headerdata */

	mdH = (void *)NewHandleClear(size);

	if(!mdH)
		goto goHome;

	HLock((Handle)mdH);
	(**mdH).descSize = size;
	(**mdH).dataFormat = 'musi';

	w = &(**mdH).headerData[0];
	_StuffGeneralEvent(*w,*(w + nrEventSize - 1),
			0,kGeneralEventNoteRequest,nrEventSize);
	nr = (NoteRequest *)(w + 1);
	nr->info.polyphony = 2;
	nr->info.typicalPolyphony = 0x00010000;
	nr->info.flags = 0;
	nr->info.reserved = 0;
	BlockMove(*iH,&nr->tone,iHSize);

	w += nrEventSize;

	*w++ = 0x60000000;

goHome:
	return (Handle)mdH;
#endif
	return nil;
	}


Handle BuildMusicScore(TDoc *d,long *duration)
	{
#if 0
	short i;
	unsigned long *w;
	long t,x;
	Handle h;

	t = 0;
	h = NewHandle(13*8 + 4);
	w = (unsigned long *)*h;

	for(i = 0; i <= 12; i++)
		{
		x = 40 * i;
		_StuffNoteEvent(*w, 0, 60+i, 80, x);
		w++;
		_StuffRestEvent(*w,x);
		t += x;
		w++;
		}
	*w++ = 0x60000000;
	*duration = t;

	return h;
#endif
	return nil;
	}


void SaveInstrumentMovie(short n, short menuItem, short menuRef)
	{
#if 0
	Movie mo;
	Track tr;
	Media me;
	short refNum;
	OSErr thisError;
	Handle headerH,scoreH;
	TDoc *d;
	Str255 movieName;
	long size;
	StandardFileReply sfr;
	TimeScale ts;
	long duration;

	d = &gDoc[n-kFirstDocWindow];


	CopyPString(movieName,d->docSpec.name);
	ConcatenatePStrings(movieName,"\p.Movie");

	StandardPutFile("\pSave Music Movie:",movieName,&sfr);
	if(!sfr.sfGood)
		goto goHome;

	thisError = CreateMovieFile(&sfr.sfFile,'TVOD',0,
 			createMovieFileDeleteCurFile,
 			&refNum,
 			&mo);
 	SetMoviePreferredVolume(mo,256);
 	SetMovieVolume(mo,256);
	tr = NewMovieTrack(mo,0,0,256);
	me = NewTrackMedia(tr,kMusicComponentType,600,0,0);
	thisError = GetMoviesError();

	headerH = BuildMusicHeader(d);
	scoreH = BuildMusicScore(d,&duration);

	size = sizeof(MusicDescription) + GetHandleSize(headerH);

	thisError = BeginMediaEdits(me);

	thisError = AddMediaSample(me,scoreH,0,GetHandleSize(scoreH),
			duration,(void *)headerH,
			1,0,0);

	thisError = InsertMediaIntoTrack(tr,0,0,duration,(1L<<16));

	thisError = EndMediaEdits(me);

 	thisError = AddMovieResource(mo,refNum,nil,nil);
	thisError = CloseMovieFile(refNum);

goHome:;
#endif
	}



