/*
	File:		NAEditInstSlider.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	

	Change History (most recent first):

		 <9>	11/14/95	dvb		Conditionally, use public interfaces.
		 <8>	 8/30/95	dvb		hier popups
		 <7>	 8/24/95	dvb		online helpp
		 <6>	 8/22/95	dvb		inst popups can be categorized
		 <5>	 8/16/95	JB		Use MusicComponent.h instead of QuickTimeComponents.h (If needed
									externally, we need a different mechanism)
		 <4>	 8/15/95	JLN		Change for read-only knobs
		 <3>	 10-2-95	dvb		getrect call
		 <2>	  6-2-95	dvb		misc

*/



#ifndef _QTMAKnobControl_
#define _QTMAKnobControl_

#include <Menus.h>
#include <Controls.h>

#ifdef UsePublicMusicInterfaces
	#include <QuickTimeComponents.h>
#else
	#include "MusicComponent.h"
#endif

typedef struct {long data[1];} *QTMAKnobList;
typedef struct {long data[1];} *QTMAKnobRef;


QTMAKnobList NewQTMAKnobList(long knobCount,MusicComponent mc);
void DisposeQTMAKnobListAt(QTMAKnobList *knobList);

void NewQTMAKnob(QTMAKnobList knobList,long knobIndex,
		KnobDescription *kd,Rect *r,long knobNumber,long refCon);

void DisposeQTMAKnob(QTMAKnobList knobList,long knobIndex);

void SetQTMAKnobActive(QTMAKnobList knobList,long knobIndex,Boolean active);


void DrawQTMAKnob(QTMAKnobList knobList,long knobIndex);
Boolean HitQTMAKnob(QTMAKnobList knobList,long knobIndex,Point p);
void TrackQTMAKnob(QTMAKnobList knobList,long knobIndex,
		Point p,short mods,ControlActionUPP actionProc);
void SetQTMAKnobValue(QTMAKnobList knobList,long knobIndex,long value);
long GetQTMAKnobValue(QTMAKnobList knobList,long knobIndex);
long GetQTMAKnobNumber(QTMAKnobList knobList,long knobIndex);
long GetQTMAKnobRefCon(QTMAKnobList knobList,long knobIndex);

void QTMAKnobRefToKnob(QTMAKnobRef ref,QTMAKnobList *knobList,long *knobIndex);

void SetQTMAKnobSettings(QTMAKnobList knobList, long knobIndex,
		Handle stringList,Handle categoryLasts,Handle categoryNames);

void GetQTMAKnobRect(QTMAKnobList knobList, long knobIndex, Rect *r);


#endif //_QTMAKnobControl_



/* --------------- */

typedef struct {long *private;} *OddMenu;

OddMenu NewOddMenu(long id);
void DisposeOddMenu(OddMenu *o);

void AddOddMenuItem(OddMenu o,StringPtr s,long itemRef);
void EnableOddMenuItem(OddMenu o,long itemRef,Boolean enable);
void AddOddMenuCategory(OddMenu o,StringPtr s);			/* use nil to be category-free */
long OddMenuSelect(OddMenu o,Point p,long choice);
void GetOddMenuText(OddMenu o,long itemRef,StringPtr s);


/* --------------- */




#define kMCPopupBoxMargin 3


typedef struct
	{
	Rect r;
	Rect frameR;
	OddMenu om;
	long choice;
	long id;

	Boolean ourMenu;
	long itemCount;

	short font,size,face;
	} MCPopup;



void InitializeMCPopup(MCPopup *mcp,Rect *r,OddMenu om,long id,long choice);
void TerminateMCPopup(MCPopup *mcp);


void DrawMCPopup(MCPopup *mcp);
Boolean ClickMCPopup(MCPopup *mcp,Point p);

short GetMCPopupChoice(MCPopup *mcp);
void SetMCPopupChoice(MCPopup *mcp,long choice);
void BumpMCPopup(MCPopup *mcp,short bump);

void SetMCPopupMenu(MCPopup *mcp,OddMenu om);


Boolean HitMCPopup(MCPopup *mcp,Point p);
long TrackMCPopup(MCPopup *mcp,Point p);

long AddMCPopupItem(MCPopup *mcp,StringPtr s,long itemRef);
long AddMCPopupCategory(MCPopup *mcp,StringPtr s);

void GetMCPopupString(MCPopup *mcp,StringPtr s);


