
/*
	File:		QTEnv.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <5>	 8/16/95	TS		voodoo magic for rs6000
		 <4>	 2/11/95	PH		add inappropriate DisposeAlias here
		 <3>	 1/20/95	JB		make RS6000 friendly
		 <2>	12/12/94	JB		Added macro for defining component calls
		 <1>	11/23/94	JB		first checked in

*/


#ifndef __QTEnv__
#define __QTEnv__

#ifdef TOOLBOX_LINKED
	#define QTPublic( name, retval, parms ) \
		pascal retval name parms
	#define QTPrivate( name, retval, parms ) \
		pascal retval name parms
	#define QTPrivateC( name, retval, parms ) \
		retval name parms
#else
	#define QTPublic( name, retval, parms ) \
		pascal retval _##name parms
	#define QTPrivate( name, retval, parms ) \
		pascal retval __##name parms
	#define QTPrivateC( name, retval, parms ) \
		retval __##name parms
#endif

#define QTInternal( name, retval, parms ) \
	pascal retval name parms
#define QTInternalC( name, retval, parms ) \
	retval name parms
	
#define QTLocal( name, retval, parms ) \
	static pascal retval name parms
#define QTLocalC( name, retval, parms ) \
	static retval name parms

// Component calls
#define QTCPublicDef( name, retval, parms, selector, parmSize ) \
	pascal retval name parms ComponentCallNow(selector, parmSize)
#define QTCPrivateDef( name, retval, parms, selector, parmSize ) \
	pascal retval name parms ComponentCallNow(selector, parmSize)

#define QTCPublic( name, retval, parms ) \
	pascal retval name parms
#define QTCPrivate( name, retval, parms ) \
	pascal retval name parms
#define QTCInternal( name, retval, parms ) \
	pascal retval name parms
#define QTCInternalC( name, retval, parms ) \
	retval name parms
#define QTCLocal( name, retval, parms ) \
	static pascal retval name parms
#define QTCLocalC( name, retval, parms ) \
	static retval name parms

// The following files use SystemSevenOrLater
// We want to use inline Gestalt, so include everyone that 
// cares about SystemSevenOrLater before including Gestalt.
// Note that this all works only because we include QTEnv.h
// before anybody else.

#include <OSUtils.h>
#include <Quickdraw.h>
#include <DiskInit.h>
#include <Folders.h>
#include <Resources.h>

#undef SystemSevenOrLater
#define SystemSevenOrLater 1
#include <Gestalt.h>

// We want to use inline GetHandleSize so we include memory
// and then define GetHandleSize to use InlineGetHandleSize

#include <Memory.h>
#define GetHandleSize InlineGetHandleSize

// I am sick of disposing aliases with disposehandle
#define DisposeAlias(x) DisposeHandle((Handle)x)

#ifndef _CreateRoutineDescriptor_
#define _CreateRoutineDescriptor_
#if GENERATINGPOWERPC
	#define ExternRoutineDescriptor(info, proc)									\
	 extern RoutineDescriptor g##proc##RD;
	
	#define CreateRoutineDescriptor(info, proc)									\
	 RoutineDescriptor g##proc##RD = BUILD_ROUTINE_DESCRIPTOR(info, proc);
	
	#define GetRoutineAddress(proc)	(&g##proc##RD)
#else
	#define ExternRoutineDescriptor(info, proc)
	#define CreateRoutineDescriptor(info, proc)

	#define GetRoutineAddress(proc)	(proc)
#endif
#endif

#endif // __QTEnv__

