
#include <Memory.h>
#include "QTMusicGraphtricks.h"
#include "BigEasyGrafish.h"


#define kTextFloat 2


static void GoLighter(unsigned long r,unsigned long g,unsigned long b);
static void GoDarker(unsigned long r,unsigned long g,unsigned long b);

void DrawStringR(Rect *r,StringPtr s)
	{
	RgnHandle rgn;

	rgn = NewRgn();
	GetClip(rgn);
	ClipRect(r);

	EraseRect(r);
	MoveTo(2+((r->left + r->right + 1)>>1),r->bottom - kTextFloat);

	DrawStringCenter(s);

	SetClip(rgn);
	DisposeRgn(rgn);
	}

void DrawStringR2(Rect *r,StringPtr s)
/*
 * Same as DrawStringR but no clipping nor erasing
 */
	{
	MoveTo(2+((r->left + r->right + 1)>>1),r->bottom - kTextFloat);

	DrawStringCenter(s);
	}



void EngraveStringR2(Rect *re,StringPtr s,
		unsigned long r,unsigned long g,unsigned long b)
	{
	OffsetRect(re,1,1);
	GoLighter(r,g,b);
	GoWhite();
	DrawStringR2(re,s);

	OffsetRect(re,-1,-1);
	GoBlack();
	DrawStringR2(re,s);
	}

void GoLighter(unsigned long r,unsigned long g,unsigned long b)
	{
	RGBFore((r+65535)>>1,(g+65535)>>1,(b+65535)>>1);
	}

void GoDarker(unsigned long r,unsigned long g,unsigned long b)
	{
	RGBFore(r>>1,g>>1,b>>1);
	}


void DrawChangedStringR(Rect *r,StringPtr old,StringPtr new)
	{
	long i;
	StringPtr oldW,newW;

	oldW = old;
	newW = new;
	i = old[0]+1;

	while(i--)
		if(*oldW++ != *newW++)
			goto drawIt;

	goto goHome;

drawIt:
	DrawStringR(r,new);
	CopyPString(old,new);

goHome:;
	}

void DrawChangedNumR(Rect *r,long *old, long new)
	{
	Str255 s;

	if(!old || (*old != new))
		{
		if(new)
			AnyBaseToPString(new,10,0,s);
		else
			s[0] = 0;
		DrawStringR(r,s);
		if(old)
			*old = new;
		}
	}


void BumpRect(Rect *r,short gap,short nextWidth)
	{
	r->left = r->right + gap;
	r->right = r->left + nextWidth;
	}


void DrawChangedNumStringR(Rect *r,StringPtr oldS,StringPtr newS,long *oldN,long newN)
	{
	RgnHandle rgn;
	long i;
	StringPtr oldW,newW;

	if(!oldN || (*oldN != newN))
		goto drawIt;

	if(!oldS)
		goto drawIt;
	oldW = oldS;
	newW = newS;
	i = oldS[0]+1;

	while(i--)
		if(*oldW++ != *newW++)
			goto drawIt;

	goto goHome;

drawIt:
	rgn = NewRgn();
	GetClip(rgn);
	ClipRect(r);

	EraseRect(r);
	ForeColor(redColor);
	PaintRect(r);
	ForeColor(blackColor);

	if(newN)
		{
		MoveTo(r->left + 3,r->bottom - kTextFloat);
		if(newN < 0)
			{
			DrawNum(newN & 0xFFFF);
			DrawChar('(');
			}
		else
			DrawNum(newN);
		DrawString("\p. ");
		}
	if(newS[0])
		{
		short x;
		x = 384;
		}
	DrawString(newS);

	CopyPString(oldS,newS);
	if(oldN)
		*oldN = newN;

	SetClip(rgn);
	DisposeRgn(rgn);
goHome:;
	}


void Frame3d(Rect *re,unsigned long r,unsigned long g,unsigned long b)
	{
	GoDarker(r,g,b);
	MoveTo(re->left-1,re->bottom);
	LineTo(re->left-1,re->top-1);
	LineTo(re->right,re->top-1);

	GoLighter(r,g,b);
	MoveTo(re->right,re->top);
	LineTo(re->right,re->bottom);
	LineTo(re->left,re->bottom);

	GoBW();
	}


void HPrintS(Handle h,StringPtr s)
	{
	long hSize,sSize;

	hSize = GetHandleSize(h);
	sSize = s[0];
	hSize += sSize;
	SetHandleSize(h,hSize);
	BlockMove(s+1,(*h)+hSize-sSize,sSize);
	}

void HPrintN(Handle h,long n)
	{
	Str255 s;

	AnyBaseToPString(n,10,0,s);
	HPrintS(h,s);
	}

